<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBaggageDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q46:ArrayOfBaggageDetail
 * @subpackage Arrays
 */
class ArrayOfBaggageDetail extends AbstractStructArrayBase
{
    /**
     * The BaggageDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\BaggageDetail[]
     */
    public $BaggageDetail;
    /**
     * Constructor method for ArrayOfBaggageDetail
     * @uses ArrayOfBaggageDetail::setBaggageDetail()
     * @param \TravelAccess\StructType\BaggageDetail[] $baggageDetail
     */
    public function __construct(array $baggageDetail = array())
    {
        $this
            ->setBaggageDetail($baggageDetail);
    }
    /**
     * Get BaggageDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\BaggageDetail[]|null
     */
    public function getBaggageDetail()
    {
        return isset($this->BaggageDetail) ? $this->BaggageDetail : null;
    }
    /**
     * Set BaggageDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\BaggageDetail[] $baggageDetail
     * @return \TravelAccess\ArrayType\ArrayOfBaggageDetail
     */
    public function setBaggageDetail(array $baggageDetail = array())
    {
        foreach ($baggageDetail as $arrayOfBaggageDetailBaggageDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfBaggageDetailBaggageDetailItem instanceof \TravelAccess\StructType\BaggageDetail) {
                throw new \InvalidArgumentException(sprintf('The BaggageDetail property can only contain items of \TravelAccess\StructType\BaggageDetail, "%s" given', is_object($arrayOfBaggageDetailBaggageDetailItem) ? get_class($arrayOfBaggageDetailBaggageDetailItem) : gettype($arrayOfBaggageDetailBaggageDetailItem)), __LINE__);
            }
        }
        if (is_null($baggageDetail) || (is_array($baggageDetail) && empty($baggageDetail))) {
            unset($this->BaggageDetail);
        } else {
            $this->BaggageDetail = $baggageDetail;
        }
        return $this;
    }
    /**
     * Add item to BaggageDetail value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\BaggageDetail $item
     * @return \TravelAccess\ArrayType\ArrayOfBaggageDetail
     */
    public function addToBaggageDetail(\TravelAccess\StructType\BaggageDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\BaggageDetail) {
            throw new \InvalidArgumentException(sprintf('The BaggageDetail property can only contain items of \TravelAccess\StructType\BaggageDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BaggageDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\BaggageDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\BaggageDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\BaggageDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\BaggageDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\BaggageDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BaggageDetail
     */
    public function getAttributeName()
    {
        return 'BaggageDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfBaggageDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
