<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBookingPassenger ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBookingPassenger
 * @subpackage Arrays
 */
class ArrayOfBookingPassenger extends AbstractStructArrayBase
{
    /**
     * The BookingPassenger
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\BookingPassenger[]
     */
    public $BookingPassenger;
    /**
     * Constructor method for ArrayOfBookingPassenger
     * @uses ArrayOfBookingPassenger::setBookingPassenger()
     * @param \TravelAccess\StructType\BookingPassenger[] $bookingPassenger
     */
    public function __construct(array $bookingPassenger = array())
    {
        $this
            ->setBookingPassenger($bookingPassenger);
    }
    /**
     * Get BookingPassenger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\BookingPassenger[]|null
     */
    public function getBookingPassenger()
    {
        return isset($this->BookingPassenger) ? $this->BookingPassenger : null;
    }
    /**
     * Set BookingPassenger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\BookingPassenger[] $bookingPassenger
     * @return \TravelAccess\ArrayType\ArrayOfBookingPassenger
     */
    public function setBookingPassenger(array $bookingPassenger = array())
    {
        foreach ($bookingPassenger as $arrayOfBookingPassengerBookingPassengerItem) {
            // validation for constraint: itemType
            if (!$arrayOfBookingPassengerBookingPassengerItem instanceof \TravelAccess\StructType\BookingPassenger) {
                throw new \InvalidArgumentException(sprintf('The BookingPassenger property can only contain items of \TravelAccess\StructType\BookingPassenger, "%s" given', is_object($arrayOfBookingPassengerBookingPassengerItem) ? get_class($arrayOfBookingPassengerBookingPassengerItem) : gettype($arrayOfBookingPassengerBookingPassengerItem)), __LINE__);
            }
        }
        if (is_null($bookingPassenger) || (is_array($bookingPassenger) && empty($bookingPassenger))) {
            unset($this->BookingPassenger);
        } else {
            $this->BookingPassenger = $bookingPassenger;
        }
        return $this;
    }
    /**
     * Add item to BookingPassenger value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\BookingPassenger $item
     * @return \TravelAccess\ArrayType\ArrayOfBookingPassenger
     */
    public function addToBookingPassenger(\TravelAccess\StructType\BookingPassenger $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\BookingPassenger) {
            throw new \InvalidArgumentException(sprintf('The BookingPassenger property can only contain items of \TravelAccess\StructType\BookingPassenger, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BookingPassenger[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\BookingPassenger|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\BookingPassenger|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\BookingPassenger|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\BookingPassenger|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\BookingPassenger|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BookingPassenger
     */
    public function getAttributeName()
    {
        return 'BookingPassenger';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfBookingPassenger
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
