<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCombinationGroup ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q30:ArrayOfCombinationGroup
 * @subpackage Arrays
 */
class ArrayOfCombinationGroup extends AbstractStructArrayBase
{
    /**
     * The CombinationGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\CombinationGroup[]
     */
    public $CombinationGroup;
    /**
     * Constructor method for ArrayOfCombinationGroup
     * @uses ArrayOfCombinationGroup::setCombinationGroup()
     * @param \TravelAccess\StructType\CombinationGroup[] $combinationGroup
     */
    public function __construct(array $combinationGroup = array())
    {
        $this
            ->setCombinationGroup($combinationGroup);
    }
    /**
     * Get CombinationGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\CombinationGroup[]|null
     */
    public function getCombinationGroup()
    {
        return isset($this->CombinationGroup) ? $this->CombinationGroup : null;
    }
    /**
     * Set CombinationGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\CombinationGroup[] $combinationGroup
     * @return \TravelAccess\ArrayType\ArrayOfCombinationGroup
     */
    public function setCombinationGroup(array $combinationGroup = array())
    {
        foreach ($combinationGroup as $arrayOfCombinationGroupCombinationGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfCombinationGroupCombinationGroupItem instanceof \TravelAccess\StructType\CombinationGroup) {
                throw new \InvalidArgumentException(sprintf('The CombinationGroup property can only contain items of \TravelAccess\StructType\CombinationGroup, "%s" given', is_object($arrayOfCombinationGroupCombinationGroupItem) ? get_class($arrayOfCombinationGroupCombinationGroupItem) : gettype($arrayOfCombinationGroupCombinationGroupItem)), __LINE__);
            }
        }
        if (is_null($combinationGroup) || (is_array($combinationGroup) && empty($combinationGroup))) {
            unset($this->CombinationGroup);
        } else {
            $this->CombinationGroup = $combinationGroup;
        }
        return $this;
    }
    /**
     * Add item to CombinationGroup value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\CombinationGroup $item
     * @return \TravelAccess\ArrayType\ArrayOfCombinationGroup
     */
    public function addToCombinationGroup(\TravelAccess\StructType\CombinationGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\CombinationGroup) {
            throw new \InvalidArgumentException(sprintf('The CombinationGroup property can only contain items of \TravelAccess\StructType\CombinationGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CombinationGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CombinationGroup
     */
    public function getAttributeName()
    {
        return 'CombinationGroup';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfCombinationGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
