<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightSearchLeg ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q8:ArrayOfFlightSearchLeg
 * @subpackage Arrays
 */
class ArrayOfFlightSearchLeg extends AbstractStructArrayBase
{
    /**
     * The FlightSearchLeg
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSearchLeg[]
     */
    public $FlightSearchLeg;
    /**
     * Constructor method for ArrayOfFlightSearchLeg
     * @uses ArrayOfFlightSearchLeg::setFlightSearchLeg()
     * @param \TravelAccess\StructType\FlightSearchLeg[] $flightSearchLeg
     */
    public function __construct(array $flightSearchLeg = array())
    {
        $this
            ->setFlightSearchLeg($flightSearchLeg);
    }
    /**
     * Get FlightSearchLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\FlightSearchLeg[]|null
     */
    public function getFlightSearchLeg()
    {
        return isset($this->FlightSearchLeg) ? $this->FlightSearchLeg : null;
    }
    /**
     * Set FlightSearchLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSearchLeg[] $flightSearchLeg
     * @return \TravelAccess\ArrayType\ArrayOfFlightSearchLeg
     */
    public function setFlightSearchLeg(array $flightSearchLeg = array())
    {
        foreach ($flightSearchLeg as $arrayOfFlightSearchLegFlightSearchLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightSearchLegFlightSearchLegItem instanceof \TravelAccess\StructType\FlightSearchLeg) {
                throw new \InvalidArgumentException(sprintf('The FlightSearchLeg property can only contain items of \TravelAccess\StructType\FlightSearchLeg, "%s" given', is_object($arrayOfFlightSearchLegFlightSearchLegItem) ? get_class($arrayOfFlightSearchLegFlightSearchLegItem) : gettype($arrayOfFlightSearchLegFlightSearchLegItem)), __LINE__);
            }
        }
        if (is_null($flightSearchLeg) || (is_array($flightSearchLeg) && empty($flightSearchLeg))) {
            unset($this->FlightSearchLeg);
        } else {
            $this->FlightSearchLeg = $flightSearchLeg;
        }
        return $this;
    }
    /**
     * Add item to FlightSearchLeg value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSearchLeg $item
     * @return \TravelAccess\ArrayType\ArrayOfFlightSearchLeg
     */
    public function addToFlightSearchLeg(\TravelAccess\StructType\FlightSearchLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\FlightSearchLeg) {
            throw new \InvalidArgumentException(sprintf('The FlightSearchLeg property can only contain items of \TravelAccess\StructType\FlightSearchLeg, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSearchLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\FlightSearchLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\FlightSearchLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\FlightSearchLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\FlightSearchLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\FlightSearchLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSearchLeg
     */
    public function getAttributeName()
    {
        return 'FlightSearchLeg';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfFlightSearchLeg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
