<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightSegment ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q36:ArrayOfFlightSegment
 * @subpackage Arrays
 */
class ArrayOfFlightSegment extends AbstractStructArrayBase
{
    /**
     * The FlightSegment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSegment[]
     */
    public $FlightSegment;
    /**
     * Constructor method for ArrayOfFlightSegment
     * @uses ArrayOfFlightSegment::setFlightSegment()
     * @param \TravelAccess\StructType\FlightSegment[] $flightSegment
     */
    public function __construct(array $flightSegment = array())
    {
        $this
            ->setFlightSegment($flightSegment);
    }
    /**
     * Get FlightSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\FlightSegment[]|null
     */
    public function getFlightSegment()
    {
        return isset($this->FlightSegment) ? $this->FlightSegment : null;
    }
    /**
     * Set FlightSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegment[] $flightSegment
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegment
     */
    public function setFlightSegment(array $flightSegment = array())
    {
        foreach ($flightSegment as $arrayOfFlightSegmentFlightSegmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightSegmentFlightSegmentItem instanceof \TravelAccess\StructType\FlightSegment) {
                throw new \InvalidArgumentException(sprintf('The FlightSegment property can only contain items of \TravelAccess\StructType\FlightSegment, "%s" given', is_object($arrayOfFlightSegmentFlightSegmentItem) ? get_class($arrayOfFlightSegmentFlightSegmentItem) : gettype($arrayOfFlightSegmentFlightSegmentItem)), __LINE__);
            }
        }
        if (is_null($flightSegment) || (is_array($flightSegment) && empty($flightSegment))) {
            unset($this->FlightSegment);
        } else {
            $this->FlightSegment = $flightSegment;
        }
        return $this;
    }
    /**
     * Add item to FlightSegment value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegment $item
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegment
     */
    public function addToFlightSegment(\TravelAccess\StructType\FlightSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\FlightSegment) {
            throw new \InvalidArgumentException(sprintf('The FlightSegment property can only contain items of \TravelAccess\StructType\FlightSegment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSegment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSegment
     */
    public function getAttributeName()
    {
        return 'FlightSegment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
