<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightSegmentCoupon ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q69:ArrayOfFlightSegmentCoupon
 * @subpackage Arrays
 */
class ArrayOfFlightSegmentCoupon extends AbstractStructArrayBase
{
    /**
     * The FlightSegmentCoupon
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSegmentCoupon[]
     */
    public $FlightSegmentCoupon;
    /**
     * Constructor method for ArrayOfFlightSegmentCoupon
     * @uses ArrayOfFlightSegmentCoupon::setFlightSegmentCoupon()
     * @param \TravelAccess\StructType\FlightSegmentCoupon[] $flightSegmentCoupon
     */
    public function __construct(array $flightSegmentCoupon = array())
    {
        $this
            ->setFlightSegmentCoupon($flightSegmentCoupon);
    }
    /**
     * Get FlightSegmentCoupon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\FlightSegmentCoupon[]|null
     */
    public function getFlightSegmentCoupon()
    {
        return isset($this->FlightSegmentCoupon) ? $this->FlightSegmentCoupon : null;
    }
    /**
     * Set FlightSegmentCoupon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegmentCoupon[] $flightSegmentCoupon
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegmentCoupon
     */
    public function setFlightSegmentCoupon(array $flightSegmentCoupon = array())
    {
        foreach ($flightSegmentCoupon as $arrayOfFlightSegmentCouponFlightSegmentCouponItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightSegmentCouponFlightSegmentCouponItem instanceof \TravelAccess\StructType\FlightSegmentCoupon) {
                throw new \InvalidArgumentException(sprintf('The FlightSegmentCoupon property can only contain items of \TravelAccess\StructType\FlightSegmentCoupon, "%s" given', is_object($arrayOfFlightSegmentCouponFlightSegmentCouponItem) ? get_class($arrayOfFlightSegmentCouponFlightSegmentCouponItem) : gettype($arrayOfFlightSegmentCouponFlightSegmentCouponItem)), __LINE__);
            }
        }
        if (is_null($flightSegmentCoupon) || (is_array($flightSegmentCoupon) && empty($flightSegmentCoupon))) {
            unset($this->FlightSegmentCoupon);
        } else {
            $this->FlightSegmentCoupon = $flightSegmentCoupon;
        }
        return $this;
    }
    /**
     * Add item to FlightSegmentCoupon value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegmentCoupon $item
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegmentCoupon
     */
    public function addToFlightSegmentCoupon(\TravelAccess\StructType\FlightSegmentCoupon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\FlightSegmentCoupon) {
            throw new \InvalidArgumentException(sprintf('The FlightSegmentCoupon property can only contain items of \TravelAccess\StructType\FlightSegmentCoupon, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSegmentCoupon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\FlightSegmentCoupon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\FlightSegmentCoupon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\FlightSegmentCoupon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\FlightSegmentCoupon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\FlightSegmentCoupon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSegmentCoupon
     */
    public function getAttributeName()
    {
        return 'FlightSegmentCoupon';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfFlightSegmentCoupon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
