<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerPrice ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPassengerPrice
 * @subpackage Arrays
 */
class ArrayOfPassengerPrice extends AbstractStructArrayBase
{
    /**
     * The PassengerPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\PassengerPrice[]
     */
    public $PassengerPrice;
    /**
     * Constructor method for ArrayOfPassengerPrice
     * @uses ArrayOfPassengerPrice::setPassengerPrice()
     * @param \TravelAccess\StructType\PassengerPrice[] $passengerPrice
     */
    public function __construct(array $passengerPrice = array())
    {
        $this
            ->setPassengerPrice($passengerPrice);
    }
    /**
     * Get PassengerPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\PassengerPrice[]|null
     */
    public function getPassengerPrice()
    {
        return isset($this->PassengerPrice) ? $this->PassengerPrice : null;
    }
    /**
     * Set PassengerPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\PassengerPrice[] $passengerPrice
     * @return \TravelAccess\ArrayType\ArrayOfPassengerPrice
     */
    public function setPassengerPrice(array $passengerPrice = array())
    {
        foreach ($passengerPrice as $arrayOfPassengerPricePassengerPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerPricePassengerPriceItem instanceof \TravelAccess\StructType\PassengerPrice) {
                throw new \InvalidArgumentException(sprintf('The PassengerPrice property can only contain items of \TravelAccess\StructType\PassengerPrice, "%s" given', is_object($arrayOfPassengerPricePassengerPriceItem) ? get_class($arrayOfPassengerPricePassengerPriceItem) : gettype($arrayOfPassengerPricePassengerPriceItem)), __LINE__);
            }
        }
        if (is_null($passengerPrice) || (is_array($passengerPrice) && empty($passengerPrice))) {
            unset($this->PassengerPrice);
        } else {
            $this->PassengerPrice = $passengerPrice;
        }
        return $this;
    }
    /**
     * Add item to PassengerPrice value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\PassengerPrice $item
     * @return \TravelAccess\ArrayType\ArrayOfPassengerPrice
     */
    public function addToPassengerPrice(\TravelAccess\StructType\PassengerPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\PassengerPrice) {
            throw new \InvalidArgumentException(sprintf('The PassengerPrice property can only contain items of \TravelAccess\StructType\PassengerPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PassengerPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\PassengerPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\PassengerPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\PassengerPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\PassengerPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\PassengerPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerPrice
     */
    public function getAttributeName()
    {
        return 'PassengerPrice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfPassengerPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
