<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerProduct ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPassengerProduct
 * @subpackage Arrays
 */
class ArrayOfPassengerProduct extends AbstractStructArrayBase
{
    /**
     * The PassengerProduct
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\PassengerProduct[]
     */
    public $PassengerProduct;
    /**
     * Constructor method for ArrayOfPassengerProduct
     * @uses ArrayOfPassengerProduct::setPassengerProduct()
     * @param \TravelAccess\StructType\PassengerProduct[] $passengerProduct
     */
    public function __construct(array $passengerProduct = array())
    {
        $this
            ->setPassengerProduct($passengerProduct);
    }
    /**
     * Get PassengerProduct value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\PassengerProduct[]|null
     */
    public function getPassengerProduct()
    {
        return isset($this->PassengerProduct) ? $this->PassengerProduct : null;
    }
    /**
     * Set PassengerProduct value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\PassengerProduct[] $passengerProduct
     * @return \TravelAccess\ArrayType\ArrayOfPassengerProduct
     */
    public function setPassengerProduct(array $passengerProduct = array())
    {
        foreach ($passengerProduct as $arrayOfPassengerProductPassengerProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerProductPassengerProductItem instanceof \TravelAccess\StructType\PassengerProduct) {
                throw new \InvalidArgumentException(sprintf('The PassengerProduct property can only contain items of \TravelAccess\StructType\PassengerProduct, "%s" given', is_object($arrayOfPassengerProductPassengerProductItem) ? get_class($arrayOfPassengerProductPassengerProductItem) : gettype($arrayOfPassengerProductPassengerProductItem)), __LINE__);
            }
        }
        if (is_null($passengerProduct) || (is_array($passengerProduct) && empty($passengerProduct))) {
            unset($this->PassengerProduct);
        } else {
            $this->PassengerProduct = $passengerProduct;
        }
        return $this;
    }
    /**
     * Add item to PassengerProduct value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\PassengerProduct $item
     * @return \TravelAccess\ArrayType\ArrayOfPassengerProduct
     */
    public function addToPassengerProduct(\TravelAccess\StructType\PassengerProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\PassengerProduct) {
            throw new \InvalidArgumentException(sprintf('The PassengerProduct property can only contain items of \TravelAccess\StructType\PassengerProduct, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PassengerProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\PassengerProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\PassengerProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\PassengerProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\PassengerProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\PassengerProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerProduct
     */
    public function getAttributeName()
    {
        return 'PassengerProduct';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfPassengerProduct
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
