<?php

namespace TravelAccess\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResponseDiagnostics ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResponseDiagnostics
 * @subpackage Arrays
 */
class ArrayOfResponseDiagnostics extends AbstractStructArrayBase
{
    /**
     * The ResponseDiagnostics
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\ResponseDiagnostics[]
     */
    public $ResponseDiagnostics;
    /**
     * Constructor method for ArrayOfResponseDiagnostics
     * @uses ArrayOfResponseDiagnostics::setResponseDiagnostics()
     * @param \TravelAccess\StructType\ResponseDiagnostics[] $responseDiagnostics
     */
    public function __construct(array $responseDiagnostics = array())
    {
        $this
            ->setResponseDiagnostics($responseDiagnostics);
    }
    /**
     * Get ResponseDiagnostics value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\ResponseDiagnostics[]|null
     */
    public function getResponseDiagnostics()
    {
        return isset($this->ResponseDiagnostics) ? $this->ResponseDiagnostics : null;
    }
    /**
     * Set ResponseDiagnostics value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\ResponseDiagnostics[] $responseDiagnostics
     * @return \TravelAccess\ArrayType\ArrayOfResponseDiagnostics
     */
    public function setResponseDiagnostics(array $responseDiagnostics = array())
    {
        foreach ($responseDiagnostics as $arrayOfResponseDiagnosticsResponseDiagnosticsItem) {
            // validation for constraint: itemType
            if (!$arrayOfResponseDiagnosticsResponseDiagnosticsItem instanceof \TravelAccess\StructType\ResponseDiagnostics) {
                throw new \InvalidArgumentException(sprintf('The ResponseDiagnostics property can only contain items of \TravelAccess\StructType\ResponseDiagnostics, "%s" given', is_object($arrayOfResponseDiagnosticsResponseDiagnosticsItem) ? get_class($arrayOfResponseDiagnosticsResponseDiagnosticsItem) : gettype($arrayOfResponseDiagnosticsResponseDiagnosticsItem)), __LINE__);
            }
        }
        if (is_null($responseDiagnostics) || (is_array($responseDiagnostics) && empty($responseDiagnostics))) {
            unset($this->ResponseDiagnostics);
        } else {
            $this->ResponseDiagnostics = $responseDiagnostics;
        }
        return $this;
    }
    /**
     * Add item to ResponseDiagnostics value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\ResponseDiagnostics $item
     * @return \TravelAccess\ArrayType\ArrayOfResponseDiagnostics
     */
    public function addToResponseDiagnostics(\TravelAccess\StructType\ResponseDiagnostics $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\ResponseDiagnostics) {
            throw new \InvalidArgumentException(sprintf('The ResponseDiagnostics property can only contain items of \TravelAccess\StructType\ResponseDiagnostics, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ResponseDiagnostics[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \TravelAccess\StructType\ResponseDiagnostics|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \TravelAccess\StructType\ResponseDiagnostics|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \TravelAccess\StructType\ResponseDiagnostics|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \TravelAccess\StructType\ResponseDiagnostics|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \TravelAccess\StructType\ResponseDiagnostics|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResponseDiagnostics
     */
    public function getAttributeName()
    {
        return 'ResponseDiagnostics';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\ArrayType\ArrayOfResponseDiagnostics
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
