<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CombinationGroupItem StructType
 * @subpackage Structs
 */
class CombinationGroupItem extends AbstractStructBase
{
    /**
     * The Key
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Key;
    /**
     * The CombinationGroup
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \TravelAccess\StructType\CombinationGroup
     */
    public $CombinationGroup;
    /**
     * Constructor method for CombinationGroupItem
     * @uses CombinationGroupItem::setKey()
     * @uses CombinationGroupItem::setCombinationGroup()
     * @param string $key
     * @param \TravelAccess\StructType\CombinationGroup $combinationGroup
     */
    public function __construct($key = null, \TravelAccess\StructType\CombinationGroup $combinationGroup = null)
    {
        $this
            ->setKey($key)
            ->setCombinationGroup($combinationGroup);
    }
    /**
     * Get Key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param string $key
     * @return \TravelAccess\StructType\CombinationGroupItem
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($key)), __LINE__);
        }
        $this->Key = $key;
        return $this;
    }
    /**
     * Get CombinationGroup value
     * @return \TravelAccess\StructType\CombinationGroup|null
     */
    public function getCombinationGroup()
    {
        return $this->CombinationGroup;
    }
    /**
     * Set CombinationGroup value
     * @param \TravelAccess\StructType\CombinationGroup $combinationGroup
     * @return \TravelAccess\StructType\CombinationGroupItem
     */
    public function setCombinationGroup(\TravelAccess\StructType\CombinationGroup $combinationGroup = null)
    {
        $this->CombinationGroup = $combinationGroup;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\CombinationGroupItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
