<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CombinationGroups StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q49:CombinationGroups
 * @subpackage Structs
 */
class CombinationGroups extends AbstractStructBase
{
    /**
     * The CombinationGroupItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \TravelAccess\StructType\CombinationGroupItem[]
     */
    public $CombinationGroupItem;
    /**
     * Constructor method for CombinationGroups
     * @uses CombinationGroups::setCombinationGroupItem()
     * @param \TravelAccess\StructType\CombinationGroupItem[] $combinationGroupItem
     */
    public function __construct(array $combinationGroupItem = array())
    {
        $this
            ->setCombinationGroupItem($combinationGroupItem);
    }
    /**
     * Get CombinationGroupItem value
     * @return \TravelAccess\StructType\CombinationGroupItem[]|null
     */
    public function getCombinationGroupItem()
    {
        return $this->CombinationGroupItem;
    }
    /**
     * Set CombinationGroupItem value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\CombinationGroupItem[] $combinationGroupItem
     * @return \TravelAccess\StructType\CombinationGroups
     */
    public function setCombinationGroupItem(array $combinationGroupItem = array())
    {
        foreach ($combinationGroupItem as $combinationGroupsCombinationGroupItemItem) {
            // validation for constraint: itemType
            if (!$combinationGroupsCombinationGroupItemItem instanceof \TravelAccess\StructType\CombinationGroupItem) {
                throw new \InvalidArgumentException(sprintf('The CombinationGroupItem property can only contain items of \TravelAccess\StructType\CombinationGroupItem, "%s" given', is_object($combinationGroupsCombinationGroupItemItem) ? get_class($combinationGroupsCombinationGroupItemItem) : gettype($combinationGroupsCombinationGroupItemItem)), __LINE__);
            }
        }
        $this->CombinationGroupItem = $combinationGroupItem;
        return $this;
    }
    /**
     * Add item to CombinationGroupItem value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\CombinationGroupItem $item
     * @return \TravelAccess\StructType\CombinationGroups
     */
    public function addToCombinationGroupItem(\TravelAccess\StructType\CombinationGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\CombinationGroupItem) {
            throw new \InvalidArgumentException(sprintf('The CombinationGroupItem property can only contain items of \TravelAccess\StructType\CombinationGroupItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CombinationGroupItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\CombinationGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
