<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Continent StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Continent
 * @subpackage Structs
 */
class Continent extends Region
{
    /**
     * The IataCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IataCode;
    /**
     * Constructor method for Continent
     * @uses Continent::setIataCode()
     * @param string $iataCode
     */
    public function __construct($iataCode = null)
    {
        $this
            ->setIataCode($iataCode);
    }
    /**
     * Get IataCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIataCode()
    {
        return isset($this->IataCode) ? $this->IataCode : null;
    }
    /**
     * Set IataCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iataCode
     * @return \TravelAccess\StructType\Continent
     */
    public function setIataCode($iataCode = null)
    {
        // validation for constraint: string
        if (!is_null($iataCode) && !is_string($iataCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iataCode)), __LINE__);
        }
        if (is_null($iataCode) || (is_array($iataCode) && empty($iataCode))) {
            unset($this->IataCode);
        } else {
            $this->IataCode = $iataCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\Continent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
