<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightSearchResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q22:FlightSearchResponse
 * @subpackage Structs
 */
class FlightSearchResponse extends SearchResponseOfPricingCombination
{
    /**
     * The CombinationGroups
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\CombinationGroups
     */
    public $CombinationGroups;
    /**
     * The FlightSegments
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSegments
     */
    public $FlightSegments;
    /**
     * Constructor method for FlightSearchResponse
     * @uses FlightSearchResponse::setCombinationGroups()
     * @uses FlightSearchResponse::setFlightSegments()
     * @param \TravelAccess\StructType\CombinationGroups $combinationGroups
     * @param \TravelAccess\StructType\FlightSegments $flightSegments
     */
    public function __construct(\TravelAccess\StructType\CombinationGroups $combinationGroups = null, \TravelAccess\StructType\FlightSegments $flightSegments = null)
    {
        $this
            ->setCombinationGroups($combinationGroups)
            ->setFlightSegments($flightSegments);
    }
    /**
     * Get CombinationGroups value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\CombinationGroups|null
     */
    public function getCombinationGroups()
    {
        return isset($this->CombinationGroups) ? $this->CombinationGroups : null;
    }
    /**
     * Set CombinationGroups value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \TravelAccess\StructType\CombinationGroups $combinationGroups
     * @return \TravelAccess\StructType\FlightSearchResponse
     */
    public function setCombinationGroups(\TravelAccess\StructType\CombinationGroups $combinationGroups = null)
    {
        if (is_null($combinationGroups) || (is_array($combinationGroups) && empty($combinationGroups))) {
            unset($this->CombinationGroups);
        } else {
            $this->CombinationGroups = $combinationGroups;
        }
        return $this;
    }
    /**
     * Get FlightSegments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\FlightSegments|null
     */
    public function getFlightSegments()
    {
        return isset($this->FlightSegments) ? $this->FlightSegments : null;
    }
    /**
     * Set FlightSegments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \TravelAccess\StructType\FlightSegments $flightSegments
     * @return \TravelAccess\StructType\FlightSearchResponse
     */
    public function setFlightSegments(\TravelAccess\StructType\FlightSegments $flightSegments = null)
    {
        if (is_null($flightSegments) || (is_array($flightSegments) && empty($flightSegments))) {
            unset($this->FlightSegments);
        } else {
            $this->FlightSegments = $flightSegments;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\FlightSearchResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
