<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightSegmentItem StructType
 * @subpackage Structs
 */
class FlightSegmentItem extends AbstractStructBase
{
    /**
     * The Key
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Key;
    /**
     * The FlightSegment
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSegment
     */
    public $FlightSegment;
    /**
     * Constructor method for FlightSegmentItem
     * @uses FlightSegmentItem::setKey()
     * @uses FlightSegmentItem::setFlightSegment()
     * @param string $key
     * @param \TravelAccess\StructType\FlightSegment $flightSegment
     */
    public function __construct($key = null, \TravelAccess\StructType\FlightSegment $flightSegment = null)
    {
        $this
            ->setKey($key)
            ->setFlightSegment($flightSegment);
    }
    /**
     * Get Key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param string $key
     * @return \TravelAccess\StructType\FlightSegmentItem
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($key)), __LINE__);
        }
        $this->Key = $key;
        return $this;
    }
    /**
     * Get FlightSegment value
     * @return \TravelAccess\StructType\FlightSegment|null
     */
    public function getFlightSegment()
    {
        return $this->FlightSegment;
    }
    /**
     * Set FlightSegment value
     * @param \TravelAccess\StructType\FlightSegment $flightSegment
     * @return \TravelAccess\StructType\FlightSegmentItem
     */
    public function setFlightSegment(\TravelAccess\StructType\FlightSegment $flightSegment = null)
    {
        $this->FlightSegment = $flightSegment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\FlightSegmentItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
