<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightSegments StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q51:FlightSegments
 * @subpackage Structs
 */
class FlightSegments extends AbstractStructBase
{
    /**
     * The FlightSegmentItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \TravelAccess\StructType\FlightSegmentItem[]
     */
    public $FlightSegmentItem;
    /**
     * Constructor method for FlightSegments
     * @uses FlightSegments::setFlightSegmentItem()
     * @param \TravelAccess\StructType\FlightSegmentItem[] $flightSegmentItem
     */
    public function __construct(array $flightSegmentItem = array())
    {
        $this
            ->setFlightSegmentItem($flightSegmentItem);
    }
    /**
     * Get FlightSegmentItem value
     * @return \TravelAccess\StructType\FlightSegmentItem[]|null
     */
    public function getFlightSegmentItem()
    {
        return $this->FlightSegmentItem;
    }
    /**
     * Set FlightSegmentItem value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegmentItem[] $flightSegmentItem
     * @return \TravelAccess\StructType\FlightSegments
     */
    public function setFlightSegmentItem(array $flightSegmentItem = array())
    {
        foreach ($flightSegmentItem as $flightSegmentsFlightSegmentItemItem) {
            // validation for constraint: itemType
            if (!$flightSegmentsFlightSegmentItemItem instanceof \TravelAccess\StructType\FlightSegmentItem) {
                throw new \InvalidArgumentException(sprintf('The FlightSegmentItem property can only contain items of \TravelAccess\StructType\FlightSegmentItem, "%s" given', is_object($flightSegmentsFlightSegmentItemItem) ? get_class($flightSegmentsFlightSegmentItemItem) : gettype($flightSegmentsFlightSegmentItemItem)), __LINE__);
            }
        }
        $this->FlightSegmentItem = $flightSegmentItem;
        return $this;
    }
    /**
     * Add item to FlightSegmentItem value
     * @throws \InvalidArgumentException
     * @param \TravelAccess\StructType\FlightSegmentItem $item
     * @return \TravelAccess\StructType\FlightSegments
     */
    public function addToFlightSegmentItem(\TravelAccess\StructType\FlightSegmentItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \TravelAccess\StructType\FlightSegmentItem) {
            throw new \InvalidArgumentException(sprintf('The FlightSegmentItem property can only contain items of \TravelAccess\StructType\FlightSegmentItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSegmentItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\FlightSegments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
