<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PricingCombination StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: q28:PricingCombination
 * @subpackage Structs
 */
class PricingCombination extends TravelProduct
{
    /**
     * The CombinationGroupKeys
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\ArrayType\ArrayOfstring
     */
    public $CombinationGroupKeys;
    /**
     * The CombinationGroups
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\ArrayType\ArrayOfCombinationGroup
     */
    public $CombinationGroups;
    /**
     * Constructor method for PricingCombination
     * @uses PricingCombination::setCombinationGroupKeys()
     * @uses PricingCombination::setCombinationGroups()
     * @param \TravelAccess\ArrayType\ArrayOfstring $combinationGroupKeys
     * @param \TravelAccess\ArrayType\ArrayOfCombinationGroup $combinationGroups
     */
    public function __construct(\TravelAccess\ArrayType\ArrayOfstring $combinationGroupKeys = null, \TravelAccess\ArrayType\ArrayOfCombinationGroup $combinationGroups = null)
    {
        $this
            ->setCombinationGroupKeys($combinationGroupKeys)
            ->setCombinationGroups($combinationGroups);
    }
    /**
     * Get CombinationGroupKeys value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\ArrayType\ArrayOfstring|null
     */
    public function getCombinationGroupKeys()
    {
        return isset($this->CombinationGroupKeys) ? $this->CombinationGroupKeys : null;
    }
    /**
     * Set CombinationGroupKeys value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \TravelAccess\ArrayType\ArrayOfstring $combinationGroupKeys
     * @return \TravelAccess\StructType\PricingCombination
     */
    public function setCombinationGroupKeys(\TravelAccess\ArrayType\ArrayOfstring $combinationGroupKeys = null)
    {
        if (is_null($combinationGroupKeys) || (is_array($combinationGroupKeys) && empty($combinationGroupKeys))) {
            unset($this->CombinationGroupKeys);
        } else {
            $this->CombinationGroupKeys = $combinationGroupKeys;
        }
        return $this;
    }
    /**
     * Get CombinationGroups value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\ArrayType\ArrayOfCombinationGroup|null
     */
    public function getCombinationGroups()
    {
        return isset($this->CombinationGroups) ? $this->CombinationGroups : null;
    }
    /**
     * Set CombinationGroups value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \TravelAccess\ArrayType\ArrayOfCombinationGroup $combinationGroups
     * @return \TravelAccess\StructType\PricingCombination
     */
    public function setCombinationGroups(\TravelAccess\ArrayType\ArrayOfCombinationGroup $combinationGroups = null)
    {
        if (is_null($combinationGroups) || (is_array($combinationGroups) && empty($combinationGroups))) {
            unset($this->CombinationGroups);
        } else {
            $this->CombinationGroups = $combinationGroups;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\PricingCombination
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
