<?php

namespace TravelAccess\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchResponse StructType
 * @subpackage Structs
 */
class SearchResponse extends AbstractStructBase
{
    /**
     * The SearchResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \TravelAccess\StructType\FlightSearchResponse
     */
    public $SearchResult;
    /**
     * Constructor method for SearchResponse
     * @uses SearchResponse::setSearchResult()
     * @param \TravelAccess\StructType\FlightSearchResponse $searchResult
     */
    public function __construct(\TravelAccess\StructType\FlightSearchResponse $searchResult = null)
    {
        $this
            ->setSearchResult($searchResult);
    }
    /**
     * Get SearchResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \TravelAccess\StructType\FlightSearchResponse|null
     */
    public function getSearchResult()
    {
        return isset($this->SearchResult) ? $this->SearchResult : null;
    }
    /**
     * Set SearchResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \TravelAccess\StructType\FlightSearchResponse $searchResult
     * @return \TravelAccess\StructType\SearchResponse
     */
    public function setSearchResult(\TravelAccess\StructType\FlightSearchResponse $searchResult = null)
    {
        if (is_null($searchResult) || (is_array($searchResult) && empty($searchResult))) {
            unset($this->SearchResult);
        } else {
            $this->SearchResult = $searchResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \TravelAccess\StructType\SearchResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
